/*=============================================================================
 * Events Touching Trigger
 * By CT_Bolt
 * Events_Touching_Trigger.js
 * Version: 1.1
 * Free for commercial and non commercial use.
 *=============================================================================*/
/*:
* @plugindesc Setup parameters for when events touch each other run common events.
* @param Event Parameters 01
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 02
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 03
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 04
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 05
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 06
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 07
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 08
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 09
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @param Event Parameters 10
* @desc MapID, EventID_A, EventID_B, CommonEventID_A, CommonEventID_B
* @default
*
* @help
* --------------------------------------------------------------------------------
* Free for commercial and non-commercial use.
* Notify & Credit CT_Bolt if used.
* Version 1.1
* --------------------------------------------------------------------------------
*
* --------------------------------------------------------------------------------
* Version History
* --------------------------------------------------------------------------------
* 1.0 - Release
* 1.1 - Updated to compatible with MV v1.6+
*/

var Imported = Imported || {};
var parameters = PluginManager.parameters('Events_Touching_Trigger');

if (parameters['Event Parameters 01'].includes(',')){var eventParam1  = parameters['Event Parameters 01'].split(',');}
if (parameters['Event Parameters 02'].includes(',')){var eventParam2  = parameters['Event Parameters 02'].split(',');}
if (parameters['Event Parameters 03'].includes(',')){var eventParam3  = parameters['Event Parameters 03'].split(',');}
if (parameters['Event Parameters 04'].includes(',')){var eventParam4  = parameters['Event Parameters 04'].split(',');}
if (parameters['Event Parameters 05'].includes(',')){var eventParam5  = parameters['Event Parameters 05'].split(',');}
if (parameters['Event Parameters 06'].includes(',')){var eventParam6  = parameters['Event Parameters 06'].split(',');}
if (parameters['Event Parameters 07'].includes(',')){var eventParam7  = parameters['Event Parameters 07'].split(',');}
if (parameters['Event Parameters 08'].includes(',')){var eventParam8  = parameters['Event Parameters 08'].split(',');}
if (parameters['Event Parameters 09'].includes(',')){var eventParam9  = parameters['Event Parameters 09'].split(',');}
if (parameters['Event Parameters 10'].includes(',')){var eventParam10 = parameters['Event Parameters 10'].split(',');}

var ctb_Game_CharacterBase_isMoving = Game_CharacterBase.prototype.isMoving;
Game_CharacterBase.prototype.isMoving = function() {
  if (eventParam1){checkEvent(eventParam1);}
  if (eventParam2){checkEvent(eventParam2);}
  if (eventParam3){checkEvent(eventParam3);}
  if (eventParam4){checkEvent(eventParam4);}
  if (eventParam5){checkEvent(eventParam5);}
  if (eventParam6){checkEvent(eventParam6);}
  if (eventParam7){checkEvent(eventParam7);}
  if (eventParam8){checkEvent(eventParam8);}
  if (eventParam9){checkEvent(eventParam9);}
  if (eventParam10){checkEvent(eventParam10);}
  ctb_Game_CharacterBase_isMoving.call(this);
  return this._realX !== this._x || this._realY !== this._y;
};

// Check Event Parameters for Collision
var checkEvent = function(ep){
    var proceed = false;

    if ($gameMap._mapId===Number(ep[0])){
      var direction1 = $gameMap._events[ep[1]]._direction;
      var direction2 = $gameMap._events[ep[2]]._direction;
      var x1=$gameMap._events[ep[1]].x, y1=$gameMap._events[ep[1]].y;
      var x2=$gameMap._events[ep[2]].x, y2=$gameMap._events[ep[2]].y;
      proceed = true;
    }

    if (proceed){
     //Event A: Facing Down - Touches Event B
     if (direction1 === 2){
       if (x1===x2){
         if (y1===y2+1){
           $gameTemp.reserveCommonEvent(ep[3]);
         }
       }
     }

     //Event B: Facing Down - Touches Event A
     if (direction2 === 2){
       if (x1===x2){
         if (y1+1===y2){
           $gameTemp.reserveCommonEvent(ep[4]);
         }
       }
     }

     //Event A: Facing Left - Touches Event B
     if (direction1 === 4){
       if (x1-1===x2){
         if (y1===y2){
           $gameTemp.reserveCommonEvent(ep[3]);
         }
       }
     }

     //Event B: Facing Left - Touches Event A
     if (direction2 === 4){
      if (x1===x2-1){
        if (y1===y2){
          $gameTemp.reserveCommonEvent(ep[4]);
        }
      }
    }

    //Event A: Facing Right - Touches Event B
    if (direction1 === 6){
      if (x1+1===x2){
        if (y1===y2){
          $gameTemp.reserveCommonEvent(ep[3]);
        }
      }
    }

    //Event B: Facing Right - Touches Event A
    if (direction2 === 6){
      if (x1===x2+1){
        if (y1===y2){
          $gameTemp.reserveCommonEvent(ep[4]);
        }
      }
    }

    //Event A: Facing Up - Touches Event B
    if (direction1 === 8){
      if (x1===x2){
        if (y1-1===y2){
          $gameTemp.reserveCommonEvent(ep[3]);
        }
      }
    }

    //Event B: Facing Up - Touches Event A
    if (direction2 === 8){
      if (x1===x2){
        if (y1===y2-1){
          $gameTemp.reserveCommonEvent(ep[4]);
        }
      }
    }
  }
}
